<?php

namespace App\Controllers;

class Ajax extends BaseController
{
    public function get($action)
    {
        $response = [];
        $user = $this->session->get('user');
        switch ($action) {
            case 'subjects':
                $id_year = (int)$this->request->getPostGet('id_year');
                $course = $this->request->getPostGet('course');                
                $response['subject'] = $this->getSubjects($id_year,$course);
                $response['age_as_on'] = $this->Template->select('template.age_as_on')
                                                            ->where('template.id_year',$id_year)->first();
                
                                                           
            break;
            case 'course':
             $id_year = (int)$this->request->getPostGet('id');
             self::$data['courses'] = $this->Template->select('template.course_name,template.course_month')->distinct()->where('template.id_year', $id_year)->where('course_name IS NOT NULL')->findAll();
              $response['courses'] = self::$data['courses'];
              $response['courses_html'] = view('user/results/course', self::$data);
              
            break;

            case 'viewcourse':
             $id_year = (int)$this->request->getPostGet('id');
             self::$data['viewcourses'] = $this->Student->select('student.course_name,student.course_month')->distinct()->where('student.id_year', $id_year)->where('course_name IS NOT NULL')->findAll();
              $response['viewcourses'] = self::$data['viewcourses'];
              $response['viewcourses_html'] = view('user/results/viewcourse', self::$data);
              
            break;

            case 'course_month':
             $id_year = (int)$this->request->getPostGet('year');
             $course = $this->request->getPostGet('course');
             self::$data['course_month'] = $this->Template->select('template.course_month')->where('template.id_year', $id_year)->where('course_name', $course)->first();
            
             $response['courses_month'] = self::$data['course_month'];
             $response['months_html'] = view('admin/coursemonth', self::$data);
             $response['subject'] = $this->Template ->select('template.id_subject ,template.max_mark,template.pass_mark,template.position')
                                                        ->where('template.id_year',$id_year)
                                                        ->where('course_name', $course)
                                                        ->findAll();
            $response['age_as_on'] = $this->Template->select('template.age_as_on')
                                                        ->where('template.id_year',$id_year)
                                                        ->where('course_name', $course)
                                                        ->first();
              
            break; 

            case 'subjects-admin':
                $id_year = (int)$this->request->getPostGet('id');
                 $response['subject'] = $this->Template ->select('template.id_subject ,template.max_mark,template.pass_mark,template.position')
                                                        ->where('template.id_year',$id_year)
                                                        ->findAll();
                $response['age_as_on'] = $this->Template->select('template.age_as_on')
                                                        ->where('template.id_year',$id_year)
                                                        ->first();
                $response['name_course'] = $this->Template->select('template.course_name,template.course_month')
                                                        ->where('template.id_year',$id_year)
                                                        ->first();
                

                break;
            case 'add-subjects':
                $formdata = [];
                parse_str($this->request->getPostGet('formdata'),$formdata);
                $response['result'] =  $this->addStudentData( $formdata , $user['id_users'] );
                break;
            case 'student-results':
                $limit = $this->request->getPostGet('length');
                $offset = $this->request->getPostGet('start');
                $search = $this->request->getPostGet('search');
                $id_users = null;
                $id_year = $this->request->getPostGet('id_year')?$this->request->getPostGet('id_year'):null;
                $course_name = $this->request->getPostGet('course_name')?$this->request->getPostGet('course_name'):null;
                $query = isset($search['value']) && $search['value'] ? $search['value'] : null;
                $response['data'] = $this->Student->getStudentDetails($limit, $offset,  false, $query, $id_year, $id_users, $course_name);
                $response['recordsFiltered'] = $this->Student->getStudentDetails($limit, $offset,  true, $query, $id_year, $id_users, $course_name);
                $response['recordsTotal'] = count($response['data']);
                $response['draw'] = $this->request->getPostGet('draw');
                break;
            case 'user-student-results':
                $limit = $this->request->getPostGet('length');
                $offset = $this->request->getPostGet('start');
                $search = $this->request->getPostGet('search');
                $id_users = $user['id_users'];
                $id_year = $this->request->getPostGet('id_year')?$this->request->getPostGet('id_year'):null;
                $course_name = $this->request->getPostGet('course_name')?$this->request->getPostGet('course_name'):null;

                $query = isset($search['value']) && $search['value'] ? $search['value'] : null;
                $response['data'] = $this->Student->getStudentDetails($limit, $offset,  false, $query, $id_year, $id_users, $course_name);
                $response['recordsFiltered'] = $this->Student->getStudentDetails($limit, $offset,  true, $query, $id_year, $id_users, $course_name);
                $response['recordsTotal'] = count($response['data']);
                $response['draw'] = $this->request->getPostGet('draw');
                break;
            case 'student-detail':
                $id = (int)$this->request->getPostGet('id');
                $id_year = (int)$this->request->getPostGet('id_year');
                $response['view'] = $this->getStudentDetail($id,$id_year);
                $response['year'] = $id_year;
                break;
            case 'student-detail-edit':
                $id = (int)$this->request->getPostGet('id');
                $id_year = (int)$this->request->getPostGet('id_year');
                $response['view'] = $this->getStudentDetailEdit($id,$id_year);
                break;
        }

        return $this->response->setJSON($response);
    }

    private function getStudentDetailEdit($id,$id_year)
    {
        self::$data['modal_title'] = 'Edit Details';
        self::$data['marks'] = $this->Mark->select('exam_center.name as exam_center ,subjects.name as subject,template.* ,student.name as name,student.*,mark.*')
                                            ->join('student','mark.id_student = student.id_student','inner')
                                            ->join('exam_center','exam_center.id_exam_center = student.id_exam_center','inner')
                                            ->join('subjects','mark.id_subject = subjects.id_subject','inner')
                                            ->join('template','(template.id_subject = mark.id_subject AND template.id_year = student.id_year AND template.course_name = student.course_name)','inner')
                                            ->where('student.id_student',$id)
                                            ->where('subjects.type',1)
                                            ->where('student.id_year',$id_year)
                                            ->findAll();

        self::$data['grades'] = $this->Mark->select('exam_center.name as exam_center ,subjects.name as subject,template.* ,student.name as name,student.*,mark.*')
                                            ->join('student','mark.id_student = student.id_student','inner')
                                            ->join('exam_center','exam_center.id_exam_center = student.id_exam_center','inner')
                                            ->join('subjects','mark.id_subject = subjects.id_subject','inner')
                                            ->join('template','(template.id_subject = mark.id_subject AND template.id_year = student.id_year AND template.course_name = student.course_name)','inner')
                                            ->where('student.id_student',$id)
                                            ->where('subjects.type',2)
                                            ->where('template.id_year',$id_year)
                                            ->findAll();                                    
        self::$data['age_as_on'] = $this->Template->select('template.age_as_on')
                                            ->where('template.id_year',$id_year)
                                            ->first();

                
        return view('user/view_edit_model', self::$data);
    }

    private function getStudentDetail($id,$id_year)
    {
        self::$data['modal_title'] = 'Student Marks';
        self::$data['marks'] = $this->Mark->select('exam_center.name as exam_center ,subjects.name as subject,template.max_mark as max_mark ,student.name as name,student.*,student.total as total,mark.*')
                                            ->join('student','mark.id_student = student.id_student','inner')
                                            ->join('exam_center','exam_center.id_exam_center = student.id_exam_center','inner')
                                            ->join('subjects','mark.id_subject = subjects.id_subject','inner')
                                            ->join('template','(template.id_subject = mark.id_subject AND template.id_year = student.id_year AND template.course_name = student.course_name)','inner')
                                            ->where('student.id_student',$id)
                                            ->where('subjects.type',1)
                                            ->where('student.id_year',$id_year)
                                            ->findAll();
        self::$data['grades'] = $this->Mark->select('exam_center.name as exam_center ,subjects.name as subject,template.max_mark as max_mark ,student.name as name,student.*,student.total as total,mark.*')
                                            ->join('student','mark.id_student = student.id_student','inner')
                                            ->join('exam_center','exam_center.id_exam_center = student.id_exam_center','inner')
                                            ->join('subjects','mark.id_subject = subjects.id_subject','inner')
                                            ->join('template','(template.id_subject = mark.id_subject AND template.id_year = student.id_year AND template.course_name = student.course_name)','inner')
                                            ->where('student.id_student',$id)
                                            ->where('subjects.type',2)
                                            ->where('template.id_year',$id_year)
                                            ->findAll();
        self::$data['age_as_on'] = $this->Template->select('template.age_as_on')
                                            ->where('template.id_year',$id_year)
                                            ->first();


        return view('admin/results/view_modal', self::$data);

    }

    private function getSubjects($id,$course)
    {   
         
        self::$data['subjects'] = $this->Template->select('subjects.*,template.max_mark')
                                                    ->join('subjects','template.id_subject = subjects.id_subject','inner')
                                                    ->where('template.id_year',$id)
                                                    ->where('subjects.type', 1)
                                                    ->where('template.course_name', $course)
                                                    ->orderBy('template.position','ASC')
                                                    ->findAll();
        self::$data['types'] = $this->Template->select('subjects.*,template.max_mark')
                                                    ->join('subjects','template.id_subject = subjects.id_subject','inner')
                                                    ->where('template.id_year',$id)
                                                    ->where('subjects.type', 2)
                                                    ->where('template.course_name', $course)
                                                    ->orderBy('subjects.position','ASC')
                                                    ->findAll();                                            

        return view('user/results/subjects',self::$data );
         
    }
    private function addStudentData( $formdata , $id_user )
    {
        $student = new \App\Models\Student();
        $student_data = [
            'name'          => $formdata['name'],
            'id_exam_center'=> $formdata['exam_center'],
            'id_user'       => $id_user, 
            'id_year'       => $formdata['add_year'],
            'father_name'   => $formdata['fname'],
            'dob-year'      =>$formdata['dob-year'],
            'dob-month'     =>$formdata['dob-month'],
            'dob-days'      =>$formdata['dob-days'],
            'gender'        => $formdata['gender'], 
            'nameofschool'  => $formdata['schoolname'],
            'totalwithoutaddl' => $formdata['totalwithoutaddl'],
            'excessover'    => $formdata['excessover'],
            'total'         => $formdata['total'],
            'result'        => $formdata['result'],
            'division'      => $formdata['division'],
            'identitymark'  => $formdata['identitymark'],
            'rollnumber'    => $formdata['roll'],
            'created_at'    => date("Y-m-d"),
            'dob'           =>$formdata['dob'],
            'identification'=>$formdata['identification'],
            'course_name'   => (isset($formdata['course_name']) ? $formdata['course_name'] : ''),
            'course_month'  => (isset($formdata['course_month']) ? $formdata['course_month'] : ''),
               
        ];

        if ($student->save($student_data)) {
            
            foreach ($formdata['subject'] as $key=>$subject){
                $data = [
                        'id_student'    => $student->insertID,
                        'id_subject'    => $subject,
                        'mark'          => $formdata['mark'][$key]
                ];
                $result = $this->Mark->save($data);
            }
            
         }
         return $result ?  true :  false;
    }
  
}
