<?php

namespace App\Controllers;

use CodeIgniter\Controller;
use CodeIgniter\HTTP\CLIRequest;
use CodeIgniter\HTTP\IncomingRequest;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

/**
 * Class BaseController
 *
 * BaseController provides a convenient place for loading components
 * and performing functions that are needed by all your controllers.
 * Extend this class in any new controllers:
 *     class Home extends BaseController
 *
 * For security be sure to declare any new methods as protected or private.
 */
class BaseController extends Controller
{
    /**
     * Instance of the main Request object.
     *
     * @var CLIRequest|IncomingRequest
     */
    protected $request;

    /**
     * An array of helpers to be loaded automatically upon
     * class instantiation. These helpers will be available
     * to all other controllers that extend BaseController.
     *
     * @var array
     */
    protected $helpers = [];

    /**
     * Constructor.
     */

    public static $data = [
		'js_files' => [],
	];

	public $is_post = false;

    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        // Do Not Edit This Line
        parent::initController($request, $response, $logger);

        // Preload any models, libraries, etc, here.

        $this->db = \Config\Database::connect();
		$this->session = \Config\Services::session();
		$this->user =  $this->session->get('user');
		$this->uri = new \CodeIgniter\HTTP\URI(); 
		$this->User = new \App\Models\User();
        $this->Year = new \App\Models\Year();
        $this->Template = new \App\Models\Template();
        $this->Subject = new \App\Models\Subject();
        $this->Exam_center = new \App\Models\Exam_center();
        $this->Student = new \App\Models\Student();
        $this->Mark = new \App\Models\Mark();
        $this->Course = new \App\Models\Course();
        $this->is_post = ($request->getMethod() == 'post');
    }

    public function adminAcess()
	{
        $user = $this->session->get('user');
		if( isset($user) && ($user['role'] == 1) )
		{
			return true;
		}
		else
		{
			throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound('Access denied');
		}
	}
    public function userAcess()
	{
        $user = $this->session->get('user');
		if( isset($user) && ($user['role'] == 2) )
		{
			return true;
		}
		else
		{
			throw \CodeIgniter\Exceptions\PageNotFoundException::forPageNotFound('Access denied');
		}
	}
}
